
import java.lang.Math;
import javafx.animation.Interpolator;
import javafx.animation.transition.RotateTransition;
import javafx.scene.effect.BlendMode;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;
import javafx.scene.shape.Arc;
import javafx.scene.shape.ArcType;

def radian = Math.PI / 180.0;

var node: Node = Group {
    translateX: 100
    translateY: 100

    // 6̉~
    content: [
        for (angle in [0..300 step 60]) {
            Circle {
                centerX: 50.0 * Math.cos(angle * radian);
                centerY: -50.0 * Math.sin(angle* radian);
                radius: 35
                fill: Color.PINK
                stroke: Color.RED
            }
        },
        // dˏ𒲐߂邽߂̔~
        Arc {
            centerX: 50,
            centerY: 0
            radiusX: 35,
            radiusY: 35
            startAngle: 180,
            length: 180
            type: ArcType.OPEN
            fill: Color.PINK
            stroke: Color.RED
        }
    ]
};

var rotationTransition = RotateTransition {
    // ]̑Ώۃm[h
    node: node
     
    // ]px̐ݒ
    // 0x720x]
    fromAngle: 0
    byAngle: 720

    // ̃Agr[g Timeline NXɏ
    duration: 5s
    repeatCount:4
    interpolate: Interpolator.EASEBOTH
    autoReverse: true
};

// ]̊Jn
rotationTransition.play();

Stage {
    title: "Rotate Sample"
    scene: Scene {
        width: 200
        height: 200
        content: node
    }
}